#!/usr/bin/env python3
# import functions
import spidev
import RPi.GPIO as GPIO

def GPIOIN(pin):
    GPIO.setup(pin , GPIO.IN)
    def closure():
        return GPIO.input(pin)
    return closure

def GPIOOUT(pin, ini = 0):
    GPIO.setup(pin , GPIO.OUT)
    GPIO.output(pin, ini)
    def closure(val):
        GPIO.output(pin, val)
        return val
    return closure

def GPIO_NUM_BIT(pin, bit):
    GPIO.setup(pin , GPIO.OUT)
    GPIO.output(pin, 0)
    sel = 1 << bit
    def closure(num):
        nonlocal sel
        GPIO.output(pin, num & sel)
    return closure

def outNumBit(nbLst, num):               # nbLst:row or col
    for f in nbLst:
        f(num)

def loopVal(lpCnt):                      # 0,1,2,3,4,5,0,1,2..
    cnt = 0
    def closure():
        nonlocal cnt
        cnt += 1
        if cnt > lpCnt:cnt = 0
        return cnt
    return closure

def noMinus(n):
    if n < 0:
        return 0
    return n

#pinDic = {'ABC':((2,0),(3,1),(4,2)),'SS':(8,1),'SPI':(0,1953000),
#    'SEL_SEN':5,'OE_ILED':23,'FIX_CLED':17,'OE_CLED':26,'HC595':16,'PWM':0,'PWM2':6}
pinDic = {'COL':((18,0),(23,1),(24,2)),'SS':(8,1),'SPI':(0,1953000),'SEL_SEN':5,'OE_ILED':6,
        'FIX_CLED':13,'OE_CLED':19,'PWM':26,'PWM2':12,'ROW':((16,0),(20,1),(21,2))}
#COL:18,23,24  SS:8  MOSI:10  MISO:9  CLK:11  SEL_SEN:5  OE_ILED:6  FIX_CLED:13 OE_CLED:19  PWM:26  ROW:16,20,21

def getPinOut(pStr):
    if pStr not in pinDic:return None
    pn = pinDic[pStr]
    if pStr in ('COL','ROW'):
        return [GPIO_NUM_BIT(pin, bit) for (pin, bit) in pn]
    elif pStr == 'SPI':
        spi = spidev.SpiDev()
        spi.open(0,pn[0])#spi.open(bus, device), bus:0, device:0/1
        spi.max_speed_hz = pn[1]  # 976000
        return spi
    elif type(pn) == tuple:
        return GPIOOUT(pn[0], pn[1])
    elif type(pn) == int:
        return GPIOOUT(pn)
    else:
        return None

def getPinIn(pStr):
    if pStr not in pinDic:return None
    pn = pinDic[pStr]
    if type(pn) == int:
        return GPIO.input(pn)
    else:
        return None

if __name__ == '__main__':
    print('impQ is running now!')